/*
 *  Пример с строками char[]
 *  Посмотрите обязательно пример Variables
 *  а потом возвращайтесь
 *  
 * Объявляем экземпляры класса 
 * 
 *   eepromArrayVariable<тип переменной, SIZE> имя;       // Value = 0 Ноль поумолчанию
 *   
 * или
 * 
 *   const тип переменной Value[] = 25;                   // Задавайте именно const что бы не жрать аперативку
 *   eepromArrayVariable<тип переменной, SIZE> имя(Value); 
 * 
 * Value - при этом будет заводской настройкой то есть если сбросить флаг и перезагрузить
 *         контроллер, то память будет опять инициализированна этим значением 
 * SIZE  - размер массива
 */

//#define USE_EEPROM_ESP8266_METHOD   // Раскоментируйте если пользуютесь ESP8266
#define USE_EEPROM_AVR_METHOD         // Раскоментируйте если пользуютесь Arduino
#include <Engineer_EasyEEPROM.h>

//AddrMachine FirstAddr(50);          // Так можно задать первый адрес в EEPROM (по умолчанию 0)

#include "EasyPrintInfo.h"            // Тут функции что бы удобно выводить в монитор порта
                                      // Это все не относится к примеру, но то де стоит изучить


// Объявим разные переменные  
const char cSSIDwifi[32] = "SSIDWiFi";                   
eepromArrayVariable<char, 32> SSIDwifi(cSSIDwifi);     // Задаем массив cSSIDwifi[32] по умолчанию

const char cPASSwifi[32] = "123456";                   
eepromArrayVariable<char, 32> PASSwifi(cPASSwifi);     // Задаем массив cPASSwifi[32] по умолчанию



void setup() {
  Serial.begin(115200);
  delay(1000); // Просто маленькая задержка
  Serial.println();
// Время компиляции скетча
  Serial.print("Compilation Date Time:\t"); Serial.println(AddrMachine::getCompilationDT());
  Serial.println();
  
// Флаг который говорит нашим переменным что делать:
// Читать из памяти или сохранить значения по умолчанию в EEPROM
  Serial.print("ReadFromMemory:\t"); Serial.println(AddrMachine::getReadFromMemory());
  Serial.println();

// Количество экземпляров класса
// По идее бесполезная инфа и нужно это вообще из библиотеки ликвидировать :D
  Serial.print("Count:\t\t"); Serial.println(AddrMachine::getCount());
  Serial.println();

// Выводим информацию о переменных в Монитор порта
  PRINT_INFO_ARRAY(SSIDwifi);
  PRINT_INFO_ARRAY(PASSwifi);

  Serial.println();
// Следующий свободный Адрес в EEPROM (не занятый нашими переменными)
  Serial.print("AddrMachine Next addr = "); Serial.println(AddrMachine::getAddrNext());
  Serial.println();
  
// Выводим код и результат его работы в Монитор порта для наглядности
  strcpy(SSIDwifi.v, "ESP8266");  Serial.print("strcpy(SSIDwifi.v, ESP8266); -> \t");     PRINT_VALUE_ARRAY(SSIDwifi);
  SSIDwifi.Save();                Serial.print("SSIDwifi.Save();             -> \t");     PRINT_VALUE_ARRAY(SSIDwifi);
  strcpy(SSIDwifi.v, "ESP8266");  Serial.print("strcpy(SSIDwifi.v, ESP8266); -> \t");     PRINT_VALUE_ARRAY(SSIDwifi);
  strcat(SSIDwifi.v, "_My");      Serial.print("strcat(SSIDwifi.v, _My);     -> \t");     PRINT_VALUE_ARRAY(SSIDwifi);
  strcat(SSIDwifi.v, "WiFi");     Serial.print("strcat(SSIDwifi.v, WiFi);    -> \t");     PRINT_VALUE_ARRAY(SSIDwifi);
  SSIDwifi.Load();                Serial.print("SSIDwifi.Load();             -> \t");     PRINT_VALUE_ARRAY(SSIDwifi);

// Обратите внимание что только первый раз при загрузке скетча флаг ReadFromMemory = 0 (false)  
// И теперь сколько бы раз мы не перезагружали контроллер           ReadFromMemory = 1 (true)
// А это значит что в памяти переменной SSIDwifi => ESP8266
// Перезагрузите контроллер и убедитесь в этом
}

void loop() {
  delay(1);
}
